﻿using gridRemoteFeatures.Models;
using Infragistics.Web.Mvc;
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;

namespace gridRemoteFeatures.Controllers
{
	public class HomeController : Controller
	{
		public ActionResult Index()
		{
			return View();
		}
		[GridDataSourceAction]
		public ActionResult GetData1()
		{
			IQueryable<Product> product = Product.GetData();
			IQueryable data = product.AsQueryable();
			//JsonResult result = new JsonResult();
			//result.JsonRequestBehavior = JsonRequestBehavior.AllowGet;
			//result.Data = new { Records = data, TotalRecordsCount = totalCount };

			return View(data);
		}
		[GridDataSourceAction]
		public JsonResult GetData(int page, int pageSize)
		{
			IQueryable<Product> product = Product.GetData();
			IQueryable data = product.AsQueryable();
			int totalCount = data.Count();
			if (Request.QueryString["page"] != null && Request.QueryString["pageSize"] != null)
			{
				data = ApplyPaging(Request.QueryString, data);
			}
			JsonResult result = new JsonResult();
			result.JsonRequestBehavior = JsonRequestBehavior.AllowGet;
			result.Data = new { Records = data, TotalRecordsCount = totalCount };

			return result;
		}
		public IQueryable ApplyPaging(NameValueCollection queryString, IQueryable data)
		{
			int recCount = Convert.ToInt32(queryString["pageSize"]);
			int startIndex = Convert.ToInt32(queryString["page"]);

			data = data.Skip(startIndex * recCount).Take(recCount);
			return data;
		}
	}
}